"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

exports.__esModule = true;
exports["default"] = _default;

var t = _interopRequireWildcard(require("@babel/types"));

var _helperModuleImports = require("@babel/helper-module-imports");

var _assert = _interopRequireDefault(require("assert"));

var _lessCompile = _interopRequireDefault(require("./less-compile"));

function _default() {
  return {
    visitor: {
      Program: {
        enter: function enter(_path, _ref) {
          var opts = _ref.opts;
          (0, _assert["default"])(!opts.entry, new Error('entry is empty'));
          (0, _assert["default"])(!Array.isArray(opts.output), new Error("output should be 'string[]', e.g: ['lib', 'es']"));
          (0, _lessCompile["default"])(opts);
        },
        exit: function exit() {}
      },
      ImportDeclaration: function (_ImportDeclaration) {
        function ImportDeclaration(_x) {
          return _ImportDeclaration.apply(this, arguments);
        }

        ImportDeclaration.toString = function () {
          return _ImportDeclaration.toString();
        };

        return ImportDeclaration;
      }(function (path) {
        var _source$value;

        var _path$node = path.node,
            specifiers = _path$node.specifiers,
            source = _path$node.source;
        var isValid = specifiers.length === 1 && t.isImportDefaultSpecifier(specifiers[0]) && ((_source$value = source.value) === null || _source$value === void 0 ? void 0 : _source$value.endsWith('.module.less'));

        if (!isValid) {
          return;
        }

        (0, _helperModuleImports.addSideEffect)(path, source.value.replace('less', 'css'));
        source.value = source.value.replace('less', 'css.js');
      })
    }
  };
}