"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = fileGenerator;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _postcss = _interopRequireDefault(require("postcss"));

var _autoprefixer = _interopRequireDefault(require("autoprefixer"));

var _assert = _interopRequireDefault(require("assert"));

var _postcssModules = _interopRequireDefault(require("postcss-modules"));

var _less = _interopRequireDefault(require("less"));

var _mkdirp = _interopRequireDefault(require("mkdirp"));

function fileGenerator(_ref) {
  var sourcePath = _ref.entry,
      output = _ref.output,
      overrideBrowserslist = _ref.overrideBrowserslist;

  var pathStat = _fs["default"].statSync(sourcePath);

  if (pathStat.isFile() && /\.module\.less$/.test(sourcePath)) {
    var lessStr = _fs["default"].readFileSync(sourcePath, {
      encoding: 'utf-8'
    });

    _less["default"].render(lessStr, {
      javascriptEnabled: true
    }, function (err, data) {
      (0, _assert["default"])(!err, JSON.stringify(err));
      output.forEach(function (folderName) {
        return _mkdirp["default"].sync(_path["default"].dirname(sourcePath).replace('src', folderName));
      });
      var fileBuildPaths = output.map(function (folderName) {
        return sourcePath.replace('src', folderName).replace('.less', '');
      });
      (0, _postcss["default"])([(0, _autoprefixer["default"])({
        overrideBrowserslist: overrideBrowserslist
      }), (0, _postcssModules["default"])({
        getJSON: function getJSON(_cssFileName, json, _outputFileName) {
          fileBuildPaths.forEach(function (p) {
            return _fs["default"].writeFileSync("".concat(p, ".css.js"), "module.exports=".concat(JSON.stringify(json)));
          });
        }
      })]).process(data.css, {
        from: undefined
      }).then(function (result) {
        fileBuildPaths.forEach(function (p) {
          return _fs["default"].writeFileSync("".concat(p, ".css"), result.css, {
            encoding: 'utf-8'
          });
        });
      });
    });
  } else if (pathStat.isDirectory()) {
    var children = _fs["default"].readdirSync(sourcePath).map(function (name) {
      return _path["default"].join(sourcePath, name);
    });

    children.forEach(function (p) {
      return fileGenerator({
        entry: p,
        output: output,
        overrideBrowserslist: overrideBrowserslist
      });
    });
  }
}